SystemOrganization addCategory: #'Glamour-Examples-Extras'!

GLMBrowserTemplate subclass: #GLMParameterizableExamplesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples-Extras'!

!GLMParameterizableExamplesBrowser commentStamp: 'TudorGirba 9/9/2012 02:50' prior: 0!
This is an abstract class that provides the infrastructure for an example browser. It is meant to work with classes that hold examples in methods.!

!GLMParameterizableExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 5/21/2013 21:53'!
buildBrowser
	browser := GLMTabulator new.
	self installTitle.
	browser
		column: #titles;
		column: #example span: 4.
	browser transmit
		to: #titles;
		andShow: [ :a | self exampleListIn: a ].
	browser transmit
		to: #example;
		fromOutsidePort: #entity;
		from: #titles;
		andShow: [ :a | self exampleIn: a ].
	^ browser! !

!GLMParameterizableExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 02:49'!
compose
	self tabulator with: [ :browser | 
		browser
			column: #titles;
			column: #example span: 4.
		browser transmit
			to: #titles;
			andShow: [ :a | self exampleListIn: a ].
		browser transmit
			to: #example;
			fromOutsidePort: #entity;
			from: #titles;
			andShow: [ :a | self exampleIn: a ] ]! !

!GLMParameterizableExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 02:50'!
exampleIn: composer
	self renderedExampleIn: composer.
	composer smalltalkCode
		title: 'Source code';
		act: [ :text :exampleClass :exampleSelector | Smalltalk tools browser fullOnClass: exampleClass selector: exampleSelector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		smalltalkClass: [ :exampleClass | exampleClass ];
		doItReceiver: [ :exampleClass | exampleClass ];
		display: [ :exampleClass :exampleSelector | exampleClass sourceCodeAt: exampleSelector ]! !

!GLMParameterizableExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 02:42'!
exampleListIn: a
	^ a list
		title: 'Examples';
		display: [ :exampleClass | self exampleSelectorsFromClass: exampleClass ];
		sorted: [ :x :y | x < y ];
		format: [ :selector | ' ' join: ((selector piecesCutWhereCamelCase reject: [:each | each endsWith: ':']) collect: #capitalized) ]! !

!GLMParameterizableExamplesBrowser methodsFor: 'hooks' stamp: 'TudorGirba 9/9/2012 02:43'!
exampleSelectorsFromClass: exampleClass
	self subclassResponsibility! !

!GLMParameterizableExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 5/21/2013 21:53'!
installTitle
	"Override this method for specific title"! !

!GLMParameterizableExamplesBrowser methodsFor: 'hooks' stamp: 'TudorGirba 9/9/2012 02:43'!
renderedExampleIn: composer
	self subclassResponsibility! !

Object subclass: #GLMMagrittePersonExample
	instanceVariableNames: 'name address'
	classVariableNames: 'SampleData'
	poolDictionaries: ''
	category: 'Glamour-Examples-Extras'!

!GLMMagrittePersonExample class methodsFor: 'examples-utils' stamp: ''!
sampleData
	"self new magritteAddressBook openOn: self new magritteAddressBookModel "
	SampleData ifNil: 
	[
		SampleData := GLMAnnouncingCollection new.
		SampleData add: (GLMMagrittePersonExample new name: 'William Shakespeare' ; address: 'Stratford-upon-Avon' ).
		SampleData add: (GLMMagrittePersonExample new name: 'Victor Hugo' ; address: 'Besançon' ).
		SampleData add: (GLMMagrittePersonExample new name: 'Mark Twain' ; address: 'Florida' ).
		SampleData add: (GLMMagrittePersonExample new name: 'Banjo Paterson' ; address: 'Narrambla' ).
	].
	^SampleData
	
! !

!GLMMagrittePersonExample class methodsFor: 'examples-utils' stamp: ''!
sampleReset
	SampleData := nil.
! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
address
	^ address! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
address: aString
	address := aString! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
descriptionAddress
	<magritteDescription>
	^ MAStringDescription new
		accessor: #address;
		label: 'Address';
		yourself! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		propertyAt: #containerBase put: nil;
		yourself! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		yourself! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
exampleSupportIdentityInSample
	^ self class sampleData includes: self.
	! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: 'TudorGirba 5/15/2015 23:02'!
gtInspectorMagritteIn: composite
	<gtInspectorPresentationOrder: 40>
	composite magritte
		title: 'Form';
		display: [ self ]! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
name: aString
	name := aString! !

!GLMMagrittePersonExample methodsFor: 'as yet unclassified' stamp: ''!
printOn: aStream
	aStream nextPutAll: '('.
	self name printOn: aStream.
	aStream nextPutAll: ','.
	self address printOn: aStream.
	aStream nextPutAll: ')'.
	self exampleSupportIdentityInSample 
		ifTrue: [ aStream nextPutAll: ' #original# '] 
		ifFalse: [ aStream nextPutAll: ' #copy# '].
	super printOn: aStream.! !

Object subclass: #GLMSTBrowserExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples-Extras'!

!GLMSTBrowserExample commentStamp: 'TudorGirba 1/4/2012 08:21' prior: 0!
self new browser openOn: (RBBrowserEnvironment new forPackageNames: #('Glamour'))!

!GLMSTBrowserExample methodsFor: 'accessing' stamp: ''!
browser
	"
	self new browser openOn: (BrowserEnvironment new forPackageNames: #('Glamour'))
	"

	| browser |
	browser := GLMTabulator new.
	browser
		row: [ :row | 
			row
				column: #category;
				column: #class;
				column: #protocol;
				column: #selector ].
	browser row: #source.	" categories "
	browser transmit
		to: #category;
		andShow: [ :a | self categoriesIn: a ].
	browser transmit
		to: #class;
		from: #outer port: #entity;
		from: #category;
		andShow: [ :a | self classesIn: a ].
	browser transmit
		to: #protocol;
		from: #outer port: #entity;
		from: #class;
		andShow: [ :a | self protocolsIn: a ].
	browser transmit
		to: #selector;
		from: #outer port: #entity;
		from: #class;
		from: #protocol;
		andShow: [ :a | self methodsIn: a ].
	browser transmit
		to: #source;
		from: #category;
		from: #class;
		from: #selector;
		andShow: [ :a | self sourceIn: a ].
	^ browser! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: ''!
categoriesIn: a
	^ a list display: [ :environment | environment categories ]! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'VincentBlondeau 2/14/2014 17:03'!
classesIn: a
	a list
		title: 'Instance';
		display: [ :environment :category | (environment classes reject: [ :each | each isMeta ]) select: [ :each | each category = category ] ];
		sorted: [ :a1 :b | a1 name < b name ];
		format: [ :class | class name ].
	^ a list
		title: 'Class';
		display: [ :environment :category | (environment classes select: [ :each | each isMeta ]) select: [ :each | each theNonMetaClass category = category ] ];
		sorted: [ :a1 :b | a1 name < b name ];
		format: [ :class | class theNonMetaClass name ]! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'AlexandreBergel 3/3/2015 10:13'!
complexityIn: a
	^ a roassal2
		title: 'Complexity';
		useExplicitNotNil;
		initializeView: [ RTMondrian new ];
		painting: [ :view :category :class :selector | 
					view nodeShape
						height: [ :model | model linesOfCode min: 50 max: 5 ];
						width: [ :model | model instVarNames size + 5 ];
						fillColor: [ :model | 
									model = class
										ifTrue: [ Color red ]
										ifFalse: [ Color white ] ].
					view
						nodes:
							(((Smalltalk organization listAtCategoryNamed: category) collect: [ :each | Smalltalk classNamed: each ])
								reject: [ :each | each isTrait ]).
					view edges connectFrom: [ :each | each superclass ].
					view treeLayout ];
		when: [ :category :class :selector | category notNil ]! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: ''!
methodsIn: a
	a list
		useExplicitNotNil;
		when: [ :environment :class :protocol | class notNil and: [ protocol notNil ] ];
		display: [ :environment :class :protocol | environment selectorsFor: protocol in: class ];
		sorted.
	^ a list
		useExplicitNotNil;
		when: [ :environment :class :protocol | class notNil and: [ protocol isNil ] ];
		display: [ :environment :class :protocol | environment selectorsForClass: class ];
		sorted! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: ''!
protocolsIn: a
	^ a list
		when: [ :environment :class | class notNil ];
		display: [ :environment :class | environment protocolsFor: class ];
		sorted! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: ''!
sourceIn: a
	a text
		title: 'Source';
		useExplicitNotNil;
		when: [ :category :class :selector | class notNil and: [ selector notNil ] ];
		display: [ :category :class :selector | class sourceCodeAt: selector ifAbsent: [ String new ] ].
	a text
		title: 'Source';
		useExplicitNotNil;
		when: [ :category :class :selector | class notNil and: [ selector isNil ] ];
		display: [ :category :class :selector | class definition ].
	^ self complexityIn: a! !

GLMExamples subclass: #GLMOtherExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples-Extras'!

!GLMOtherExamples commentStamp: '<historical>' prior: 0!
self open!

!GLMOtherExamples methodsFor: 'other examples' stamp: ''!
expander
	"self new expander openOn: Collection withAllSubclasses"
	| browser expander |
	browser := GLMTabulator new.
	browser title: 'Example'.
	expander := GLMExpander new.
	expander title: 'Methods'.
	expander display: [:class | class methods ].
	expander show: [ :a | 
		a title: [:x | x selector ].
		a text 
			display: #getSource].
	browser column: #classes; column: #methods.
	browser transmit to: #classes; andShow: [:a | 
		a list title: 'Classes' ].
	browser transmit to: #methods; from: #classes; andShow: [:a | 
		a custom: expander ].
	^ browser
! !

!GLMOtherExamples methodsFor: 'file examples' stamp: 'AndreHora 5/3/2013 14:31'!
fileExplorer
	<glmBrowser: 'File Explorer' input: 'FileDirectory default'>
	"self new fileExplorer openOn: FileDirectory default"
	| browser |
	browser := GLMTabulator new.
	browser 
		column: #folders;
		column: [ :col | col row: #files span: 2; row: #preview ] span: 2. 
	browser transmit to: #folders; andShow: [ :a | 
		a tree 
			title: 'Folders'; 
			children: [ :fd | fd directoryNames collect: [ :each | FileSystem / fd pathName, fd pathNameDelimiter asString, each ] ]; 
			format: [ :folder | folder localName ] ].
	browser transmit to: #files; from: #folders; andShow: [ :a |
		a list 
			format: [ :fd | fd localName ]; 
			display: [ :fd | fd fileNames collect: [:each | FileSystem / fd pathName, fd pathNameDelimiter asString, each ] ] ].
	browser transmit to: #preview; from: #files; andShow: [ :a |
		a text
			display: [ :file | file fullName ] ].
	^ browser! !

!GLMOtherExamples methodsFor: 'file examples' stamp: 'AndreHora 5/3/2013 14:25'!
fileFinder
	<glmBrowser: 'File Finder' input: 'FileDirectory default'>
	"self new fileFinder openOn: FileDirectory default"

	| browser |
	browser := GLMFinder new.
	browser show: 	[ :a | 
		a list
			display: [ :fd | fd entries collect: [:each | 
					FileSystem / fd pathName, fd pathNameDelimiter asString, each name]];
			format: [ :fd | fd localName ];
			when: [ :fd | fd directoryEntry isDirectory ]].
	browser show: 	[ :a | 
		a text
			display: [ :fd | fd fullName ];
			when: [ :fd | fd directoryEntry isDirectory not ] ].
	^ browser! !
